#!/bin/bash

. /lib/dracut-lib.sh

source $NEWROOT/etc/opt/slapos/get-network.sh
SLAPOS_CFG_FILE="$NEWROOT"/etc/opt/slapos/slapos.cfg
WENDELIN_REFERENCE=$(sed -n '/computer_id = /p' "$SLAPOS_CFG_FILE" | sed 's/computer_id = \(.*\)/\1/g')
WENDELIN_URL=$(sed -n '/master_url = /p' "$SLAPOS_CFG_FILE" | sed 's/master_url = \(.*\)/\1/g')
SLAPOS_KEY_FILE="$NEWROOT"$(sed -n '/key_file = /p' "$SLAPOS_CFG_FILE" | sed 's/key_file = \(.*\)/\1/g')
SLAPOS_CERT_FILE="$NEWROOT"$(sed -n '/cert_file = /p' "$SLAPOS_CFG_FILE" | sed 's/cert_file = \(.*\)/\1/g')

SCAN_FILE=/var/log/metadata_collect.log

sed -i "s|%SCAN_FILE%|$SCAN_FILE|g;s|%WENDELIN_REFERENCE%|$WENDELIN_REFERENCE|g;s|%SLAPOS_KEY_FILE%|$SLAPOS_KEY_FILE|g;s|%SLAPOS_CERT_FILE%|$SLAPOS_CERT_FILE|g;s|%WENDELIN_URL%|$WENDELIN_URL|g" /etc/flb.conf

timestamp_cmd='date +"%Y/%m/%d %H:%M %Z"'
/sbin/fluent-bit -e /etc/libfluentbit_wendelin.so -c /etc/flb.conf &
flb_pid=$!

echo "{\"beginning_date\": \"$(eval "$timestamp_cmd")\"}" >> $SCAN_FILE
/sbin/metadata-collect-agent $NEWROOT/usr/bin $SCAN_FILE
/sbin/metadata-collect-agent $NEWROOT/usr/sbin $SCAN_FILE
echo "{\"end_date\": \"$(eval "$timestamp_cmd")\", \"end_marker\": \"fluentbit_end\"}" >> $SCAN_FILE

wait $flb_pid
