#!/bin/bash

set -e

# get the root of the git repository (requires git to be installed)
GIT_ROOT=$(git rev-parse --show-toplevel)
cd $GIT_ROOT

# define useful variables
source generation/00env.sh
sha_list=installation/images-sha512.list

networkcache-upload --conf ../tls-access-to-shacache/test.cfg --id ocean.nexedi.com:river:debian:"$KERNEL_VERSION" --file "$UEFI_IMAGE_NAME"

echo $(sha512sum "$UEFI_IMAGE_NAME" | cut -d' ' -f1) "$hash_comment" >> "$sha_list"
echo "$UEFI_IMAGE_NAME"
git add "$sha_list"
git commit -m "installation: Add an image hash."
git push
