
To perform the following instructions, some packages are needed.
They are installed by `dependencies.sh` of this directory.

## Create the keys

WARNING: This is probably NOT what you want to do.

Run the script `mkkeys.sh`:
```bash
    mkdir -p generate_keys && cd generate_keys && cp ../mkkeys.sh . && ./mkkeys.sh
```

## Signing a UEFI application

You have nothing special to do. This is performed by dracut (called in `installation/install.sh`) according to `dracut.conf` (generated by `installation/install.sh` from `dracut.conf.in`).

## Add keys to the firmware:
Run `efi-readvar`

### if PK, KEK or db is not empty
1. Reboot and, in the BIOS, disable Secure Boot (SB) and remove every keys.
2. Then if we assume the keys have the name mkkeys.sh gives them:
    * Add the Platform Key (the authority key for the machine).
```bash
efi-updatevar -f PK.auth PK
```
    * Add the Key Exchange Key (the authority key for the db and dbx certificates and hashes)
```bash
efi-updatevar -a -c KEK.crt -k PK.key KEK
```
    * Replace the current whitelist certificate
````bash
efi-updatevar -f -c DB.crt -k KEK.key db
````
(replace -f with -a to append another whitelist certificate instead of replacing the old one)

### Troubleshooting
Some general informations:
1. As a general matter, with Secure Boot (SB) disabled and no key, every key should be addable.
2. A Platform Key is needed for Secure Boot (SB) to be enabled.
3. To add or modify a key, you need the private key of the upper level (the Platform Key is its own upper level key).

#### Common errors

* Error: `Failed to update <var>: Operation not permitted`
It happens when trying to delete or replace a key. It may be resolved by making it mutable:
```bash
lsattr /sys/firmware/efi/efivars/{db,dbx,KEK,PK}*
```
"----i--------------" before the key means it is set as immutable. To make it mutable:
```bash
chattr -i /sys/firmware/efi/efivars/<key>
```
Example:
```bash
chattr -i /sys/firmware/efi/efivars/db-d719b2cb-3d3a-4596-a3bc-dad00e67656f
```
Recommanded: make everything immutable after your operation. To do so, perform the same command with `+i` instead of `-i`. Same example:
```bash
chattr +i /sys/firmware/efi/efivars/db-d719b2cb-3d3a-4596-a3bc-dad00e67656f
```

* Error: `Cannot write to db, wrong filesystem permissions`
It may be resolved by providing the upper level private key (after the `-k` option of `efi-updatevar`). Note that it can happen even in root mode, as the keys are stored on a separate filesystem.
